/* Copyright (C) 2004 Stephane GALLAND <stephane.galland@utbm.fr>

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
                                                                               
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   This program is free software; you can redistribute it and/or modify
*/

#include "error.h"

/* ERROR MESSAGES */

static const char* ERRORMESSAGES[] = {

  /* ERR_NONE */
  0,

  /* ERR_MEM_NOTENOUGHCONTIGUE */
  "not enough contigue memory",

  /* ERR_ASM_INSTRUCTIONFAILED */
  "assembler instruction has failed",
  /* ERR_ASM_NULLPARAMETER */
  "parameter must not be null",
  /* ERR_ASM_NOTENOUGHMEMORY */
  "not enough memory",
  /* ERR_ASM_NOTMEMMANAGER */
  "unable to contact the memory manager",
  /* ERR_ASM_INVALIDADDRESS */
  "invalid memory address",
  /* ERR_ASM_NODECLARE */
  "no DECLARE before this instruction",
  /* ERR_ASM_INVALIDREGISTER */
  "invalid register index",
  /* ERR_ASM_NOTPREVIOUSTEST */
  "can find any previous test result",
  /* ERR_ASM_DIVISIONBYZERO */
  "division by zero",
  /* ERR_ASM_NOCODESEGMENT */
  "no code segment found",
  /* ERR_ASM_END */
  "Quit with a call to END",

  /* ERR_VM_INVALIDORDINALCOUNTER */
  "invalid ordinal counter for the next assembler instruction to run"

} ;

/** Replies the error message which corresponds
 *  to the specified error message.
 *
 * @param n is the error number.
 * @return the error message.
 */
const char* error_msg(ERRORNUM n) {
  if ( n<ERR_QTY_OF_SUPPORTED_ERRORS ) {
    return ERRORMESSAGES[n] ;
  }
  return 0 ;
}

