/* Copyright (C) 2004 Stephane GALLAND <stephane.galland@utbm.fr>

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
                                                                               
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   This program is free software; you can redistribute it and/or modify
*/
#ifndef __EW_ERROR_H__
#define __EW_ERROR_H__

/** Macro to affect an error message to the current player.
 */
#define VMERROR(__message__) VM_setErrorMsg(vm,(__message__))

/** Macro to affect an assembler message to the current player.
 */
#define ASMERROR(__message__) {						\
  d_error("\terror in %s, see below for more details\n",__CURRENTASM__); \
  VMERROR(__message__);							\
}

/** Macro to affect an assembler message to the current player.
 */
#ifdef __DEBUG__
#define ASMERRORNOLOG(__message__) VM_setErrorMsg(vm,(__message__));
#else
#define ASMERRORNOLOG(__message__) { d_error("",__CURRENTASM__); VM_setErrorMsg(vm,(__message__)); }
#endif

/* ERROR MESSAGES */

/** List of the error numbers.
 */
typedef enum {

  ERR_NONE,

  ERR_MEM_NOTENOUGHCONTIGUE,

  ERR_ASM_INSTRUCTIONFAILED,
  ERR_ASM_NULLPARAMETER,
  ERR_ASM_NOTENOUGHMEMORY,
  ERR_ASM_NOTMEMMANAGER,
  ERR_ASM_INVALIDADDRESS,
  ERR_ASM_NODECLARE,
  ERR_ASM_INVALIDREGISTER,
  ERR_ASM_NOTPREVIOUSTEST,
  ERR_ASM_DIVISIONBYZERO,
  ERR_ASM_NOCODESEGMENT,
  ERR_ASM_END,

  ERR_VM_INVALIDORDINALCOUNTER,

  ERR_QTY_OF_SUPPORTED_ERRORS,

} ERRORNUM ;

/** Replies the error message which corresponds
 *  to the specified error message.
 *
 * @param n is the error number.
 * @return the error message.
 */
const char* error_msg(ERRORNUM n) ;

#endif
