/* Copyright (C) 2004 Stephane GALLAND <stephane.galland@utbm.fr>

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
                                                                               
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   This program is free software; you can redistribute it and/or modify
*/

#include <stdlib.h>
#include <ctype.h>

#include "string.h"

/** Compares two strings. This function is similar to
 *  strcmp() but it does not care about the case.
 *
 * @param str1
 * @param str2
 * @param length is the maximal length to compare
 * @return -1 if (str1<str2), 0 if (str1==str2) or 1
 */
short compareStrings(char* str1, char* str2, unsigned long size) {
  unsigned long i;
  for(i=0; i<size; i++) {
    if ((str1[i]=='\0')||
	(str2[i]=='\0')||
	(tolower(str1[i])!=tolower(str2[i]) ) ) 
      return (tolower(str1[i]) - tolower(str2[i])) ;
  }
  return 0 ;
}

/** Duplicates the specified string. 
 *  This function is equivalent to strndup() which
 *  does not exists on all platform includes.
 *
 * @param str
 * @param length is the maximal length to duplicate
 * @return the resulting string
 */
char* duplicateString(char* str, unsigned long size) {
  char* s ;
  if ((str==NULL)||(size==0)) return NULL ;
  s = (char*)malloc(sizeof(char)*(size+1)) ;
  if ( s != NULL ) {
    unsigned long i;
    s[size] = '\0' ;
    for(i=0; i<size; i++) {
      s[i] = str[i] ;
      if ( s[i] == '\0' ) return s ;
    }
  }
  return s ;
}
