/* Copyright (C) 2004 Stephane GALLAND <stephane.galland@utbm.fr>

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
                                                                               
   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
   This program is free software; you can redistribute it and/or modify
*/

#ifndef __EW_STRING_H__
#define __EW_STRING_H__

#include <string.h>

/** Compares two strings. This function is similar to
 *  strncmp() but it does not care about the case.
 *  This function is equivalent to strncasecmp() which
 *  does not exists on all platform includes.
 *
 * @param str1
 * @param str2
 * @param length is the maximal length to compare
 * @return -1 if (str1<str2), 0 if (str1==str2) or 1
 */
short compareStrings(char* str1, char* str2, unsigned long size) ;

/** Duplicates the specified string. 
 *  This function is equivalent to strndup() which
 *  does not exists on all platform includes.
 *
 * @param str
 * @param length is the maximal length to duplicate
 * @return the resulting string
 */
char* duplicateString(char* str, unsigned long size) ;

#endif
